//CN-Palm Summer 2003
//07/10/03 Added login form to get host, port, name and pass
//11/10/03 Default server/port details in login screen
//12/10/03 Added the default menu
//21/10/03 Freed old text handles when text in login form is set

#include "palm.h"

static void    InitApp(void);
static void    EndApp(void);
static Boolean LoginFormHandler(EventType *event);
static Boolean MainFormHandler(EventType *event);
static void    FldClearText(FieldType *fldP);
static void    set_server_details(void);

UInt32 romVersion;
Char name[20];
static Char pass[20];
static Int32 recvNextTick;
static Int8  chatType = CT_PUBLIC;

//History: 27/08/03 Created by Samuel
static void FldClearText(FieldType *fldP)
{
	EventType event;
	FldSetSelection(fldP, 0, FldGetTextLength(fldP));

	MemSet(&event, sizeof(EventType), 0);
	event.eType = keyDownEvent;
	event.data.keyDown.chr = 8; //Backspace
	EvtAddEventToQueue(&event);
}

static void set_server_details()
{
	FormType  *frm = FrmGetActiveForm();
	FieldType *fldPtr;
	MemHandle handle, oldH;
	Char *str;

	//ToDo: Edit text and malloc size
	handle = MemHandleNew(16);
	str = MemHandleLock(handle);
	StrCopy(str, "216.34.65.183");
	MemHandleUnlock(handle);

	//ToDo: Edit res ID
	fldPtr = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, HostFld));

	oldH = FldGetTextHandle(fldPtr); //Delete existing text
	if (oldH) MemHandleUnlock(oldH);

	FldSetTextHandle(fldPtr, handle);
	FldDrawField(fldPtr);

	//ToDo: Edit text and malloc size
	handle = MemHandleNew(6);
	str = MemHandleLock(handle);
	StrCopy(str, "5002");
	MemHandleUnlock(handle);

	//ToDo: Edit res ID
	fldPtr = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, PortFld));

	oldH = FldGetTextHandle(fldPtr); //Delete existing text
	if (oldH) MemHandleUnlock(oldH);

	FldSetTextHandle(fldPtr, handle);
	FldDrawField(fldPtr);
}

static Boolean LoginFormHandler(EventType *event)
{
	Boolean handled = false;
	EventType updateEvt;
	FormType  *frm;
	FieldType *fldPtr;
	Char *host, *port_str, *str;
	UInt16 port;

	switch (event->eType) {
	case frmOpenEvent:
		frm = FrmGetActiveForm();
		FrmDrawForm(frm);
		FrmSetFocus(frm, FrmGetObjectIndex(frm, NameFld));

		MemSet(&updateEvt, sizeof(EventType), 0);
		updateEvt.eType = frmUpdateEvent;
		updateEvt.data.frmUpdate.formID = FrmGetActiveFormID();
		EvtAddEventToQueue(&updateEvt);
		handled = true;
		set_server_details();
		break;

	case frmUpdateEvent:
		FrmDrawForm(FrmGetActiveForm());
		handled = true;
		break;

	case ctlSelectEvent:
		switch(event->data.ctlEnter.controlID) {
		case ConnectBtn:
			frm = FrmGetActiveForm();

			fldPtr = FrmGetObjectPtr(frm,
				FrmGetObjectIndex(frm, HostFld));
			if (FldGetTextLength(fldPtr) < 1) break;
			host = FldGetTextPtr(fldPtr);

			fldPtr = FrmGetObjectPtr(frm,
				FrmGetObjectIndex(frm, PortFld));
			if (FldGetTextLength(fldPtr) < 1) break;
			port_str = FldGetTextPtr(fldPtr);

			port = StrAToI(port_str);
			TCPSetHost(host, port);

			fldPtr = FrmGetObjectPtr(frm,
				FrmGetObjectIndex(frm, NameFld));
			if (FldGetTextLength(fldPtr) < 1) break;
			str = FldGetTextPtr(fldPtr);
			MemMove(name, str, StrLen(str));

			fldPtr = FrmGetObjectPtr(frm,
				FrmGetObjectIndex(frm, PassFld));
			if (FldGetTextLength(fldPtr) < 1) break;
			str = FldGetTextPtr(fldPtr);
			MemMove(pass, str, StrLen(str));

			if (TCPConnect())
			{
				CSendLogin(name, pass);
				FrmGotoForm(MainForm);
			}
			break;
		default:
			break;
		}
		break;

	case nilEvent:
		handled = true;
		break;
	default:
		break;
	}

	return handled;
}

static Boolean MainFormHandler(EventType *event)
{
	Boolean handled = false;
	EventType updateEvt;
	FormType  *frm;
	FieldType *textFPtr;
	Char      *textPtr;

	switch (event->eType) {
	case frmOpenEvent:
		frm = FrmGetActiveForm();
		FrmDrawForm(frm);
		FrmSetFocus(frm, FrmGetObjectIndex(frm, InputFld));

		MemSet(&updateEvt, sizeof(EventType), 0);
		updateEvt.eType = frmUpdateEvent;
		updateEvt.data.frmUpdate.formID = FrmGetActiveFormID();
		EvtAddEventToQueue(&updateEvt);
		handled = true;
		break;

	case frmUpdateEvent:
		FrmDrawForm(FrmGetActiveForm());
		WRefresh();
//		DRefresh();
		handled = true;
		break;

	case ctlSelectEvent:
		switch(event->data.ctlEnter.controlID) {
		case SendBtn:
			frm = FrmGetActiveForm();
			textFPtr = FrmGetObjectPtr(frm,
				FrmGetObjectIndex(frm, InputFld));
			//Length check
			if (FldGetTextLength(textFPtr) < 1) break;
			textPtr = FldGetTextPtr(textFPtr);

			CProcessInput(textPtr, chatType);
			//Only clear the field when connected to save
			// re-typing it
			if (bConnected)
				FldClearText(textFPtr);

//			WinEraseWindow(); //Comment out to keep debug
						// messages?
//			FrmDrawForm(frm);
			handled = true;
			break;
		default:
			break;
		}
		break;

	case popSelectEvent:
		if(event->data.ctlEnter.controlID == TypePopup)
			chatType = event->data.popSelect.selection;
		break;
	case nilEvent:
		if (!bConnected)
		{
			FrmPopupForm(LoginForm);
		}
		else if (recvNextTick < TimGetTicks())
		{
			TCPReceive();
			recvNextTick = TimGetTicks() + recvTick;
		}
		CProcessLine(TCPReadLine());
		handled = true;
		break;
	default:
		break;
	}

	return handled;
}

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags) {
  if (cmd != sysAppLaunchCmdNormalLaunch)
    return 0;

  //Check OS version (Palm OS 1.0 safe)
  FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
  if (romVersion < sysMakeROMVersion(3,0,0,sysROMStageRelease,0)) {
    AppLaunchWithCommand(sysFileCDefaultApp,
      sysAppLaunchCmdNormalLaunch, NULL);
  }

  InitApp();
  EventLoop();
  EndApp();

  return 0;
}

static void InitApp()
{
	bConnected = 0;
	WInit();
	TCPInit();
	//TCPSetHost(192,168,0,1, 1102);
	FrmGotoForm(MainForm);
}

Boolean ApplicationHandleEvent(EventType *event) {
  Boolean handled = false;

  switch (event->eType) {
  case frmLoadEvent:
    {
      UInt16   formID = event->data.frmLoad.formID;
      FormType *frm   = FrmInitForm(formID);
      FrmSetActiveForm(frm);

      switch(formID) {
      case MainForm:
        FrmSetEventHandler(frm, (FormEventHandlerPtr)MainFormHandler);
        handled = true;
        break;
      case LoginForm:
        FrmSetEventHandler(frm,(FormEventHandlerPtr)LoginFormHandler);
        handled = true;
        break;
      }
    }
    break;

  default:
    break;
  }

  return handled;
}

void EventLoop() {
  EventType event;
  Err err;

  do {
    EvtGetEvent(&event, 800);

    if (!SysHandleEvent(&event))
      if (!MenuHandleEvent(0, &event, &err))
        if (!ApplicationHandleEvent(&event))
          FrmDispatchEvent(&event);

  } while(event.eType != appStopEvent);
}

static void EndApp() {
  TCPDisconnect();
  TCPEnd();
  WEnd();
  FrmCloseAllForms();
}
